
using Microsoft.VisualStudio.Modeling.Diagrams;
using System.Drawing;
using Microsoft.VisualStudio.Modeling;
using DslFactory.Utilities.DteCodeModel;
using EnvDTE;

namespace Dslfactory.wcfLanguage
{
 public partial class ServiceShape
 {
  /// <summary>
  /// Represented interface
  /// </summary>
  public Service Service
  {
   get
   {
    return ModelElement as Service;
   }
  }

  /// <summary>
  /// When double-clicking on a shape, we get to the type
  /// </summary>
  /// <param name="e"></param>
  public override void OnDoubleClick(DiagramPointEventArgs e)
  {
   KnownCodeTypes knownCodeTypes = KnownCodeTypes.FromStore(Store);
   if (knownCodeTypes == null)
    return;
    CodeType codeType = knownCodeTypes.GetFullNamedType(Service.FullName);
    if (codeType == null)
     return;

    IncrementalGenerator.TryToShow(codeType as CodeElement);
  }
 }
}
